addHook("PlayerThink", function(player)
	if player.distributesuper == nil then player.distributesuper = 2 end
	if player.wepchancooldown == nil then player.wepchancooldown = 0 end
	if player.wepchancooldown > 0 then player.wepchancooldown = $1-1 end
	if player.boosttype == nil then player.boosttype = 1 end
	if player.multitype == nil then player.multitype = 2 end
	if player.arceustype == nil then player.arceustype = 1 end
	if player.abilboostflag == nil then player.abilboostflag = 0 end
	if player.multiabilflag == nil then player.multiabilflag = 0 end
	if player.arceustime == nil then player.arceustime = 0 end
	if player.boostpower == nil then player.boostpower = 2 end
	if player.nextprevsupyes == nil then player.nextprevsupyes = 1 end
	if player.superrunmusic == nil then player.superrunmusic = 2 end
end)
//These are the player specific variables! Let's hope they don't cause mischeif..

local function Forcesuper(player)
    if gametype == GT_COOP then
		if player.mo and player.valid and not player.exiting and (player.rings > 0) and All7Emeralds(emeralds) and player.wepchancooldown == 0 and not player.powers[pw_carry] then
			if not player.powers[pw_super]
				player.mo.momz = 0
				player.mo.momx = 0
				player.mo.momy = 0
				player.powers[pw_super] = 1
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k46)
				player.wepchancooldown = 55
			end
		end
	end
end

//Why add these commands when Super Run allows the use of Next/Prev weapon to switch between Super and Normal?
//Some characters use these buttons, and so do other LUAs.. So!
//They're here so the buttons can be rebound from the default!
//Hence why you can turn the switching off via a command!

local function Forcenormal(player)
    if gametype == GT_COOP then
		if player.mo and player.valid and not player.exiting and (player.rings > 0) and All7Emeralds(emeralds) and player.wepchancooldown == 0 and not player.powers[pw_carry] then
			if player.powers[pw_super]
				player.powers[pw_super] = 0
				S_StartSound(player.mo, sfx_s3k9c)
				player.mo.color = player.skincolor
				player.mo.state = player.mo.state
				player.wepchancooldown = 55
				P_SpawnShieldOrb(player)
				P_RestoreMusic(player)
			end
		end
	end
end

COM_AddCommand("Superrun_Forcesuper", Forcesuper)
COM_AddCommand("Superrun_Forcenormal", Forcenormal)

COM_AddCommand("Superrun_help", function(player)
	CONS_Printf(player, "")
	CONS_Printf(player, "This command shows a small bit of info about other commands!")
	CONS_Printf(player, "To learn more, enter SuperRun_ and then the words before the -")
	CONS_Printf(player, "")
	CONS_Printf(player, "SuperRun_")
	CONS_Printf(player, "Type - This allows you to change ring distribution type.")
	CONS_Printf(player, "Multiability_Type - Enable/Disable Multiability conditions.")
	CONS_Printf(player, "AbilityBoost_Type - Enable/Disable Actionspd boost conditions.")
	CONS_Printf(player, "AbilityBoost_Power - Set the strength of the Actionspd boost. (Will not accept bugs with strength above 2)")
	CONS_Printf(player, "GodMode_Type - Enable/Disable God conditions.")
	CONS_Printf(player, "Force - Enable/Disable using Next/Prev Weapon to force Super/Normal.")
	CONS_Printf(player, "Music - Enable/Disable Super music conditions.")
	CONS_Printf(player, "ForceSuper - Forces you to become Super.")
	CONS_Printf(player, "ForceNormal - Forces you to become Non-Super.")
	CONS_Printf(player, "")
end)
		

COM_AddCommand("Superrun_type", function(player, typeans)
	if typeans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to change the distribition method of rings for super run.")
		CONS_Printf(player, "This command ONLY works for Co-Op")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - SuperRun")
		CONS_Printf(player, "2 - Sonic 2 3D/AGES (50 rings on load,  (Default)")
		CONS_Printf(player, "3 - Sonic 2 3D/AGES (50 when rings 0)")
		CONS_Printf(player, "4 - Max (9999 rings always)")
		CONS_Printf(player, "5 - Recharge (Gain rings when not super)")
		CONS_Printf(player, "6 - Drain (Always loose rings)")
		CONS_Printf(player, "")
	else
		local typestring = string.lower(typeans)
		if typestring == "0"
		or typestring == "off"
		or typestring == "disable"
		or typestring == "no"
		or typestring == "false"
			if player.distributesuper == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already off!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been turned off.")
				CONS_Printf(player, "")
				player.distributesuper = 0
			end
		elseif typestring == "1"
		or typestring == "superrun"
		or typestring == "super"
			if player.distributesuper == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Super Run!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Super Run.")
				CONS_Printf(player, "")
				player.distributesuper = 1
			end
		elseif typestring == "2"
		or typestring == "sonic2"
		or typestring == "ages"
		or typestring == "sonic23d"
		or typestring == "sonic2ages"
		or typestring == "default"
		or typestring == "normal"
		or typestring == "yes"
		or typestring == "true"
		or typestring == "on"
			if player.distributesuper == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Normal Sonic 2!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Normal Sonic 2.")
				CONS_Printf(player, "")
				player.distributesuper = 2
			end
		elseif typestring == "3"
		or typestring == "sonic2alt"
		or typestring == "agesalt"
			if player.distributesuper == 3
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Alternate Sonic 2!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Alternate Sonic 2.")
				CONS_Printf(player, "")
				player.distributesuper = 3
			end
		elseif typestring == "4"
		or typestring == "9999"
		or typestring == "max"
			if player.distributesuper == 4
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Maximum!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Maximum.")
				CONS_Printf(player, "")
				player.distributesuper = 4
			end
		elseif typestring == "5"
		or typestring == "recharge"
			if player.distributesuper == 5
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Recharge!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Recharge.")
				CONS_Printf(player, "")
				player.distributesuper = 5
			end
		elseif typestring == "6"
		or typestring == "drain"
		or typestring == "bleed" 
			if player.distributesuper == 6
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type is already Drain!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Distribution type has been changed to Drain.")
				CONS_Printf(player, "")
				player.distributesuper = 6
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)


COM_AddCommand("Superrun_Multiability_type", function(player, multians)
	if multians == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to change how you obtain Multiability.")
		CONS_Printf(player, "This command ONLY works for Co-Op")
		CONS_Printf(player, "This command is also disabled in BCZ1.")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - Collect Super Sneakers")
		CONS_Printf(player, "2 - Collect Invulnerability (Default)")
		CONS_Printf(player, "3 - Always")
		CONS_Printf(player, "")
	else
		local multistring = string.lower(multians)
		if multistring == "0"
		or multistring == "off"
		or multistring == "disable"
		or multistring == "no"
		or multistring == "false"
			if player.multitype == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability is already off!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability has been turned off.")
				CONS_Printf(player, "")
				player.multitype = 0
			end
		elseif multistring == "1"
		or multistring == "sneakers"
		or multistring == "supersneakers"
			if player.multitype == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability is already set to Super Sneakers!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability has been changed to activate with Super Sneakers.")
				CONS_Printf(player, "")
				player.multitype = 1
			end
		elseif multistring == "2"
		or multistring == "default"
		or multistring == "invulnerability"
		or multistring == "invincibility"
			if player.multitype == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability is already set to Invulnerability!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability has been changed to activate with Invulnerability.")
				CONS_Printf(player, "")
				player.multitype = 2
			end
		elseif multistring == "3"
		or multistring == "yes"
		or multistring == "on"
		or multistring == "true"
		or multistring == "always"
			if player.multitype == 3
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability is already set to always!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Multiability has been changed to always be active.")
				CONS_Printf(player, "")
				player.multitype = 3
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)

COM_AddCommand("Superrun_Abilityboost_type", function(player, boostans)
	if boostans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to change how you obtain a character ability boost.")
		CONS_Printf(player, "This command ONLY works for Co-Op")
		CONS_Printf(player, "This command is also disabled in BCZ1.")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - Collect Super Sneakers (Default)")
		CONS_Printf(player, "2 - Collect Invulnerability")
		CONS_Printf(player, "3 - Always")
		CONS_Printf(player, "")
	else
		local booststring = string.lower(boostans)
		if booststring == "0"
		or booststring == "off"
		or booststring == "disable"
		or booststring == "no"
		or booststring == "false"
			if player.boosttype == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost is already off!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost has been turned off.")
				CONS_Printf(player, "")
				player.boosttype = 0
			end
		elseif booststring == "1"
		or booststring == "default"
		or booststring == "sneakers"
		or booststring == "supersneakers"
			if player.boosttype == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost is already set to Super Sneakers!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost has been changed to activate with Super Sneakers.")
				CONS_Printf(player, "")
				player.boosttype = 1
			end
		elseif booststring == "2"
		or booststring == "invulnerability"
		or booststring == "invincibility"
			if player.boosttype == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost is already set to Invulnerability!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost has been changed to activate with Invulnerability.")
				CONS_Printf(player, "")
				player.boosttype = 2
			end
		elseif booststring == "3"
		or booststring == "yes"
		or booststring == "on"
		or booststring == "true"
		or booststring == "always"
			if player.boosttype == 3
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost is already set to always!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Ability Boost has been changed to always be active.")
				CONS_Printf(player, "")
				player.boosttype = 3
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)

COM_AddCommand("Superrun_Abilityboost_power", function(player, powahans)
		if powahans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to change how how strong the character ability boost is.")
		CONS_Printf(player, "If you don't wish for a boost, turn it off via \"Abilityboost_type\".")
		CONS_Printf(player, "You can pick any integer from 2 to 25 (At your own risk.), with the default being 2.")
		CONS_Printf(player, "")
		CONS_Printf(player, "This command ONLY works for Co-Op")
		CONS_Printf(player, "The base command is disabled in BCZ1, so this has no effect in BCZ1 by extension.")
		CONS_Printf(player, "")
	else
		local powahstring = string.lower(powahans)
		if powahstring == "0"
		or powahstring == "off"
		or powahstring == "no"
		or powahstring == "disable"
		or powahstring == "false"
		or powahstring == "1"
			CONS_Printf(player, "")
			CONS_Printf(player, "If you don't wish for a boost, turn it off via \"Abilityboost_type\".")
			CONS_Printf(player, "")
		elseif powahstring == "2"
		or powahstring == "default"
			if player.boostpower == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *2!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *2.")
				CONS_Printf(player, "")
				player.boostpower = 2
			end
		elseif powahstring == "3"
			if player.boostpower == 3
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *3!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *3.")
				CONS_Printf(player, "")
				player.boostpower = 3
			end
		elseif powahstring == "4"
			if player.boostpower == 4
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *4!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *4.")
				CONS_Printf(player, "")
				player.boostpower = 4
			end
		elseif powahstring == "5"
			if player.boostpower == 5
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *5!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *5.")
				CONS_Printf(player, "")
				player.boostpower = 5
			end
		elseif powahstring == "6"
			if player.boostpower == 6
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *6!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *6.")
				CONS_Printf(player, "")
				player.boostpower = 6
			end
		elseif powahstring == "7"
		if player.boostpower == 7
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *7!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *7.")
				CONS_Printf(player, "")
				player.boostpower = 7
			end
		elseif powahstring == "8"
		if player.boostpower == 8
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *8!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *8.")
				CONS_Printf(player, "")
				player.boostpower = 8
			end
		elseif powahstring == "9"
		if player.boostpower == 9
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *9!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *9.")
				CONS_Printf(player, "")
				player.boostpower = 9
			end
		elseif powahstring == "10"
		if player.boostpower == 10
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *10!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *10.")
				CONS_Printf(player, "")
				player.boostpower = 10
			end
		elseif powahstring == "11"
		if player.boostpower == 11
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *11!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *11.")
				CONS_Printf(player, "")
				player.boostpower = 11
			end
		elseif powahstring == "12"
		if player.boostpower == 12
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *12!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *12.")
				CONS_Printf(player, "")
				player.boostpower = 12
			end
		elseif powahstring == "13"
		if player.boostpower == 13
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *13!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *13.")
				CONS_Printf(player, "")
				player.boostpower = 13
			end
		elseif powahstring == "14"
		if player.boostpower == 14
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *14!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *14.")
				CONS_Printf(player, "")
				player.boostpower = 14
			end
		elseif powahstring == "15"
		if player.boostpower == 15
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *15!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *15.")
				CONS_Printf(player, "")
				player.boostpower = 15
			end
		elseif powahstring == "16"
		if player.boostpower == 16
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *16!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *16.")
				CONS_Printf(player, "")
				player.boostpower = 16
			end
		elseif powahstring == "17"
		if player.boostpower == 17
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *17!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *17.")
				CONS_Printf(player, "")
				player.boostpower = 17
			end
		elseif powahstring == "18"
		if player.boostpower == 18
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *18!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *18.")
				CONS_Printf(player, "")
				player.boostpower = 18
			end
		elseif powahstring == "19"
		if player.boostpower == 19
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *19!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *19.")
				CONS_Printf(player, "")
				player.boostpower = 19
			end
		elseif powahstring == "20"
		if player.boostpower == 20
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *20!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *20.")
				CONS_Printf(player, "")
				player.boostpower = 20
			end
		elseif powahstring == "21"
		if player.boostpower == 21
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *21!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *21.")
				CONS_Printf(player, "")
				player.boostpower = 21
			end
		elseif powahstring == "22"
		if player.boostpower == 22
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *22!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *22.")
				CONS_Printf(player, "")
				player.boostpower = 22
			end
		elseif powahstring == "23"
		if player.boostpower == 23
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *23!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *23.")
				CONS_Printf(player, "")
				player.boostpower = 23
			end
		elseif powahstring == "24"
		if player.boostpower == 24
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *24!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *24.")
				CONS_Printf(player, "")
				player.boostpower = 24
			end
		elseif powahstring == "25"
		if player.boostpower == 25
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength is already *25!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Boost strength has been set to *25...")
				CONS_Printf(player, "")
				player.boostpower = 25
			end
		elseif powahstring == "69" //Secret :3
		if player.boostpower == 69
				CONS_Printf(player, "")
				CONS_Printf(player, "It's already 69.")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Nice.")
				CONS_Printf(player, "")
				player.boostpower = 69
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Did you select a number from 2 to 25?")
			CONS_Printf(player, "")
		end
	end
end)

COM_AddCommand("Superrun_Godmode_type", function(player, arceusans)
	if arceusans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to change how you obtain the god flag.")
		CONS_Printf(player, "This command ONLY works for Co-Op")
		CONS_Printf(player, "This command is also disabled in BCZ1.")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - Multiability and Ability Boost (Default)")
		CONS_Printf(player, "2 - Always")
		CONS_Printf(player, "")
	else
		local arceusstring = string.lower(arceusans)
		if arceusstring == "0"
		or arceusstring == "off"
		or arceusstring == "disable"
		or arceusstring == "no"
		or arceusstring == "false"
			if player.arceustype == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode is already off!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode has been turned off.")
				CONS_Printf(player, "")
				player.arceustype = 0
			end
		elseif arceusstring == "1"
		or arceusstring == "default"
		or arceusstring == "sneakers"
		or arceusstring == "supersneakers"
		or arceusstring == "invulnerability"
		or arceusstring == "invincibility"
		or arceusstring == "both"
		or arceusstring == "multi"
		or arceusstring == "multiability"
		or arceusstring == "boost"
		or arceusstring == "abilityboost"
			if player.arceustype == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode is already set to Multiability and Ability Boost!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode has been changed to activate with Multiability and Ability Boost.")
				CONS_Printf(player, "")
				player.arceustype = 1
			end
		elseif arceusstring == "2"
		or arceusstring == "yes"
		or arceusstring == "on"
		or arceusstring == "true"
		or arceusstring == "always"
			if player.arceustype == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode is already set to always..!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Godmode has been changed to always be active. (Oh no)")
				CONS_Printf(player, "")
				player.arceustype = 2
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)

COM_AddCommand("Superrun_force", function(player, forceans)
	if forceans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to enable or disable forced super with the Next and Previous weapon buttons.")
		CONS_Printf(player, "This command ONLY works for Co-Op, as the ability to force is Co-Op only.")
		CONS_Printf(player, "You can bind the commands SUPERRUN_FORCESUPER and SUPERRUN_FORCENORMAL to different buttons using keybinds.")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - On (Default)")
		CONS_Printf(player, "")
	else
		local forcestring = string.lower(forceans)
		if forcestring == "0"
		or forcestring == "off"
		or forcestring == "disable"
		or forcestring == "no"
		or forcestring == "false"
			if player.nextprevsupyes == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Forcing super via the Next/Prev Wep keys is already disabled!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "You can no longer force super using Next/Prev Wep.")
				CONS_Printf(player, "")
				player.nextprevsupyes = 0
			end
		elseif forcestring == "1"
		or forcestring == "default"
		or forcestring == "yes"
		or forcestring == "true"
		or forcestring == "on"
			if player.nextprevsupyes == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "You can already force super using Next/Prev weapon keys!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "You can now use the Next/Prev weapon keys to force super.")
				CONS_Printf(player, "")
				player.nextprevsupyes = 1
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)

COM_AddCommand("Superrun_Music", function(player, musicans)
	if musicans == nil then
		CONS_Printf(player, "")
		CONS_Printf(player, "This command allows you to enable or disable Super Music.")
		CONS_Printf(player, "This command ONLY applies to Vanilla characters and supported custom characters.")
		CONS_Printf(player, "")
		CONS_Printf(player, "Options:")
		CONS_Printf(player, "0 - Off")
		CONS_Printf(player, "1 - Character Specific (Default)")
		CONS_Printf(player, "2 - When Hyper")
		CONS_Printf(player, "3 - Default Music")
		CONS_Printf(player, "4 - When Super and Hyper")
		CONS_Printf(player, "")
	else
		local musicforcestring = string.lower(musicans)
		if musicforcestring == "0"
		or musicforcestring == "off"
		or musicforcestring == "disable"
		or musicforcestring == "no"
		or musicforcestring == "false"
			if player.superrunmusic == 0
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music is already disabled!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music will no longer play.")
				CONS_Printf(player, "")
				player.superrunmusic = 0
			end
		elseif musicforcestring == "1"
		or musicforcestring == "yes"
		or musicforcestring == "true"
		or musicforcestring == "on"
		or musicforcestring == "super"
		or musicforcestring == "character"
		or musicforcestring == "music"
			if player.superrunmusic == 1
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music is already character specific!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music will now play depending on character.")
				CONS_Printf(player, "")
				player.superrunmusic = 1
			end
		elseif musicforcestring == "2"
		or musicforcestring == "hyper"
		or musicforcestring == "god"
		or musicforcestring == "default"
			if player.superrunmusic == 2
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music is already set to play when Hyper!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music will now play when Hyper.")
				CONS_Printf(player, "")
				player.superrunmusic = 2
			end
			elseif musicforcestring == "3"
		or musicforcestring == "default"
		or musicforcestring == "srb2"
			if player.superrunmusic == 3
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music is already set to play default music!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music will now play the default music.")
				CONS_Printf(player, "")
				player.superrunmusic = 3
			end
			elseif musicforcestring == "4"
		or musicforcestring == "both"
			if player.superrunmusic == 4
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music is already set to play when Super and Hyper!")
				CONS_Printf(player, "")
			else
				CONS_Printf(player, "")
				CONS_Printf(player, "Super Music will now play when Super and Hyper.")
				CONS_Printf(player, "")
				player.superrunmusic = 4
			end
		else
			CONS_Printf(player, "")
			CONS_Printf(player, "This is an invalid option! Please enter a valid setting.")
			CONS_Printf(player, "")
		end
	end
end)